package net.dries007.tfc.client.render;

import net.dries007.tfc.objects.Wood;
import net.dries007.tfc.objects.blocks.wood.BlockChestTFC;
import net.dries007.tfc.objects.te.TEChestTFC;
import net.minecraft.block.BlockChest;
import net.minecraft.client.model.ModelChest;
import net.minecraft.client.model.ModelLargeChest;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import java.util.EnumMap;

import static net.dries007.tfc.Constants.MOD_ID;

@SideOnly(Side.CLIENT)
public class TESRChestTFC extends TileEntitySpecialRenderer<TEChestTFC>
{
    private static final EnumMap<Wood, ResourceLocation> SINGLE_TEXTURES = new EnumMap<>(Wood.class);
    private static final EnumMap<Wood, ResourceLocation> DOUBLE_TEXTURES = new EnumMap<>(Wood.class);
    private static final EnumMap<Wood, ResourceLocation> TRAP_SINGLE_TEXTURES = new EnumMap<>(Wood.class);
    private static final EnumMap<Wood, ResourceLocation> TRAP_DOUBLE_TEXTURES = new EnumMap<>(Wood.class);
    static
    {
        for (Wood wood : Wood.values())
        {
            SINGLE_TEXTURES.put(wood, new ResourceLocation(MOD_ID, "textures/model/wood/chest/" + wood.name().toLowerCase() + ".png"));
            DOUBLE_TEXTURES.put(wood, new ResourceLocation(MOD_ID, "textures/model/wood/chest_double/" + wood.name().toLowerCase() + ".png"));
            TRAP_SINGLE_TEXTURES.put(wood, new ResourceLocation(MOD_ID, "textures/model/wood/chest_trap/" + wood.name().toLowerCase() + ".png"));
            TRAP_DOUBLE_TEXTURES.put(wood, new ResourceLocation(MOD_ID, "textures/model/wood/chest_trap_double/" + wood.name().toLowerCase() + ".png"));
        }
    }

    private final ModelChest simpleChest = new ModelChest();
    private final ModelChest largeChest = new ModelLargeChest();

    @Override
    public void func_192841_a(TEChestTFC te, double x, double y, double z, float partialTicks, int destroyStage, float alpha)
    {
        GlStateManager.func_179126_j();
        GlStateManager.func_179143_c(515);
        GlStateManager.func_179132_a(true);
        int meta = 0;

        if (te.func_145830_o())
        {
            BlockChestTFC block = te.func_145838_q();
            meta = te.func_145832_p();

            if (block != null && meta == 0)
            {
                block.func_176455_e(te.func_145831_w(), te.func_174877_v(), te.func_145831_w().func_180495_p(te.func_174877_v()));
                meta = te.func_145832_p();
            }

            te.func_145979_i();
        }

        if (te.field_145992_i != null || te.field_145991_k != null) return;

        ModelChest modelchest;
        if (te.field_145990_j == null && te.field_145988_l == null)
        {
            modelchest = simpleChest;

            if (destroyStage >= 0)
            {
                func_147499_a(field_178460_a[destroyStage]);
                GlStateManager.func_179128_n(5890);
                GlStateManager.func_179094_E();
                GlStateManager.func_179152_a(4.0F, 4.0F, 1.0F);
                GlStateManager.func_179109_b(0.0625F, 0.0625F, 0.0625F);
                GlStateManager.func_179128_n(5888);
            }
            else if (te.func_145980_j() == BlockChest.Type.TRAP)
            {
                func_147499_a(TRAP_SINGLE_TEXTURES.get(te.getWood()));
            }
            else
            {
                func_147499_a(SINGLE_TEXTURES.get(te.getWood()));
            }
        }
        else
        {
            modelchest = largeChest;

            if (destroyStage >= 0)
            {
                func_147499_a(field_178460_a[destroyStage]);
                GlStateManager.func_179128_n(5890);
                GlStateManager.func_179094_E();
                GlStateManager.func_179152_a(8.0F, 4.0F, 1.0F);
                GlStateManager.func_179109_b(0.0625F, 0.0625F, 0.0625F);
                GlStateManager.func_179128_n(5888);
            }
            else if (te.func_145980_j() == BlockChest.Type.TRAP)
            {
                func_147499_a(TRAP_DOUBLE_TEXTURES.get(te.getWood()));
            }
            else
            {
                func_147499_a(DOUBLE_TEXTURES.get(te.getWood()));
            }
        }

        GlStateManager.func_179094_E();
        GlStateManager.func_179091_B();

        if (destroyStage < 0) GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, alpha);

        GlStateManager.func_179109_b((float)x, (float)y + 1.0F, (float)z + 1.0F);
        GlStateManager.func_179152_a(1.0F, -1.0F, -1.0F);
        GlStateManager.func_179109_b(0.5F, 0.5F, 0.5F);
        int rotation = 0;

        switch (meta)
        {
            case 2:
                rotation = 180;
                if (te.field_145990_j != null) GlStateManager.func_179109_b(1.0F, 0.0F, 0.0F);
                break;
            case 3:
                rotation = 0;
                break;
            case 4:
                rotation = 90;
                break;
            case 5:
                rotation = -90;
                if (te.field_145988_l != null) GlStateManager.func_179109_b(0.0F, 0.0F, -1.0F);
                break;
        }

        GlStateManager.func_179114_b((float)rotation, 0.0F, 1.0F, 0.0F);
        GlStateManager.func_179109_b(-0.5F, -0.5F, -0.5F);
        float lidAngle = te.field_145986_n + (te.field_145989_m - te.field_145986_n) * partialTicks;

        if (te.field_145992_i != null)
        {
            float f1 = te.field_145992_i.field_145986_n + (te.field_145992_i.field_145989_m - te.field_145992_i.field_145986_n) * partialTicks;
            if (f1 > lidAngle) lidAngle = f1;
        }

        if (te.field_145991_k != null)
        {
            float f2 = te.field_145991_k.field_145986_n + (te.field_145991_k.field_145989_m - te.field_145991_k.field_145986_n) * partialTicks;
            if (f2 > lidAngle) lidAngle = f2;
        }

        lidAngle = 1.0F - lidAngle;
        lidAngle = 1.0F - lidAngle * lidAngle * lidAngle;
        modelchest.field_78234_a.field_78795_f = -(lidAngle * ((float)Math.PI / 2F));
        modelchest.func_78231_a();
        GlStateManager.func_179101_C();
        GlStateManager.func_179121_F();
        GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);

        if (destroyStage >= 0)
        {
            GlStateManager.func_179128_n(5890);
            GlStateManager.func_179121_F();
            GlStateManager.func_179128_n(5888);
        }
    }
}
