package net.dries007.tfc.objects.blocks.wood;

import com.google.common.collect.ImmutableList;
import net.dries007.tfc.objects.Wood;
import net.dries007.tfc.util.OreDictionaryHelper;
import net.minecraft.block.BlockLeaves;
import net.minecraft.block.BlockPlanks;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockRenderLayer;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nonnull;
import java.util.EnumMap;
import java.util.List;
import java.util.Random;

public class BlockLeavesTFC extends BlockLeaves
{
    private static final EnumMap<Wood, BlockLeavesTFC> MAP = new EnumMap<>(Wood.class);

    public static BlockLeavesTFC get(Wood wood)
    {
        return MAP.get(wood);
    }

    public final Wood wood;

    public BlockLeavesTFC(Wood wood)
    {
        this.wood = wood;
        if (MAP.put(wood, this) != null) throw new IllegalStateException("There can only be one.");
        func_180632_j(field_176227_L.func_177621_b().func_177226_a(field_176236_b, true).func_177226_a(field_176237_a, true));
        field_185686_c = true; // there doesn't seem to be an even for catching changing this, so lets not bother
        OreDictionaryHelper.register(this, "tree", "leaves");
        OreDictionaryHelper.register(this, "tree", "leaves", wood);
    }

    @Override
    protected BlockStateContainer func_180661_e()
    {
        return new BlockStateContainer(this, field_176236_b, field_176237_a);
    }

    @SuppressWarnings("deprecation")
    @Override
    public IBlockState func_176203_a(int meta)
    {
        return this.func_176223_P().func_177226_a(field_176237_a, (meta & 0b01) == 0b01).func_177226_a(field_176236_b, (meta & 0b10) == 0b10);
    }

    @SuppressWarnings("deprecation")
    @Override
    public AxisAlignedBB func_180646_a(IBlockState blockState, IBlockAccess worldIn, BlockPos pos)
    {
        return field_185506_k;
    }

    @SuppressWarnings("deprecation")
    @Override
    public boolean func_149686_d(IBlockState state)
    {
        return false;
    }

    @Override
    public int func_176201_c(IBlockState state)
    {
        return (state.func_177229_b(field_176237_a) ? 0b01 : 0) | (state.func_177229_b(field_176236_b) ? 0b10 : 0);
    }

    @Override
    public BlockPlanks.EnumType func_176233_b(int meta)
    {
        return null;
    }

    @Nonnull
    @Override
    public List<ItemStack> onSheared(@Nonnull ItemStack item, IBlockAccess world, BlockPos pos, int fortune)
    {
        return ImmutableList.of(new ItemStack(this));
    }

    @Override
    public Item func_180660_a(IBlockState state, Random rand, int fortune)
    {
        return Item.func_150898_a(BlockSaplingTFC.get(wood));
    }

    @SideOnly(Side.CLIENT)
    public BlockRenderLayer func_180664_k()
    {
        return BlockRenderLayer.CUTOUT_MIPPED;
    }

    public void func_180634_a(World worldIn, BlockPos pos, IBlockState state, Entity entityIn)
    {
        //Player will take damage when falling through leaves if fall is over 9 blocks, fall damage is then set to 0. 
        entityIn.func_180430_e((entityIn.field_70143_R - 6), 1.0F); // TODO: 17/4/18 Balance fall distance reduction. 
        entityIn.field_70143_R = 0;
        //Entity motion is reduced by leaves.
        entityIn.field_70159_w *= 0.1D;
        entityIn.field_70181_x *= 0.1D;
        entityIn.field_70179_y *= 0.1D;
    }
}
