package net.dries007.tfc.objects.blocks.wood;

import net.dries007.tfc.objects.Wood;
import net.dries007.tfc.util.OreDictionaryHelper;
import net.minecraft.block.BlockLog;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import java.util.EnumMap;

import net.minecraft.block.BlockLog.EnumAxis;

public class BlockLogTFC extends BlockLog
{
    private static final EnumMap<Wood, BlockLogTFC> MAP = new EnumMap<>(Wood.class);
    public static final PropertyBool PLACED = PropertyBool.func_177716_a("placed");
    public static final PropertyBool SMALL = PropertyBool.func_177716_a("small");
    public static final AxisAlignedBB SMALL_AABB_Y = new AxisAlignedBB(0.25, 0, 0.25, 0.75, 1, 0.75);
    public static final AxisAlignedBB SMALL_AABB_X = new AxisAlignedBB(0, 0.25, 0.25, 1, 0.75, 0.75);
    public static final AxisAlignedBB SMALL_AABB_Z = new AxisAlignedBB(0.25, 0.25, 0, 0.75, 0.75, 1);

    public static BlockLogTFC get(Wood wood)
    {
        return MAP.get(wood);
    }

    public final Wood wood;

    public BlockLogTFC(Wood wood)
    {
        this.wood = wood;
        if (MAP.put(wood, this) != null) throw new IllegalStateException("There can only be one.");
        func_180632_j(field_176227_L.func_177621_b().func_177226_a(field_176299_a, BlockLog.EnumAxis.Y).func_177226_a(PLACED, true).func_177226_a(SMALL, false));
        setHarvestLevel("axe", 0);
        OreDictionaryHelper.register(this, "log", "wood");
        OreDictionaryHelper.register(this, "log", "wood", wood);
    }

    @SuppressWarnings("deprecation")
    @Override
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess source, BlockPos pos)
    {
        if (!state.func_177229_b(SMALL)) return field_185505_j;
        switch (state.func_177229_b(field_176299_a))
        {
            case X: return SMALL_AABB_X;
            case Y: return SMALL_AABB_Y;
            case Z: return SMALL_AABB_Z;
        }
        return field_185505_j;
    }

    @SuppressWarnings("deprecation")
    @Override
    public boolean func_149662_c(IBlockState state)
    {
        return !state.func_177229_b(SMALL);
    }

    @SuppressWarnings("deprecation")
    @Override
    public boolean func_149686_d(IBlockState state)
    {
        return !state.func_177229_b(SMALL);
    }

    @Override
    protected BlockStateContainer func_180661_e()
    {
        return new BlockStateContainer(this, field_176299_a, PLACED, SMALL);
    }

    @Override
    public IBlockState func_176203_a(int meta)
    {
        return func_176223_P().func_177226_a(field_176299_a, EnumAxis.values()[meta & 0b11]).func_177226_a(PLACED, (meta & 0b100) == 0b100).func_177226_a(SMALL, (meta & 0b1000) == 0b1000);
    }

    @Override
    public int func_176201_c(IBlockState state)
    {
        return state.func_177229_b(field_176299_a).ordinal() | (state.func_177229_b(PLACED) ? 0b100 : 0)  | (state.func_177229_b(SMALL) ? 0b1000 : 0);
    }

    @Override
    public IBlockState func_180642_a(World worldIn, BlockPos pos, EnumFacing facing, float hitX, float hitY, float hitZ, int meta, EntityLivingBase placer)
    {
        return super.func_180642_a(worldIn, pos, facing, hitX, hitY, hitZ, meta, placer).func_177226_a(PLACED, true).func_177226_a(SMALL, placer.func_70093_af());
    }
}
