package net.dries007.tfc.objects.items.pottery;

import net.dries007.tfc.objects.Metal;
import net.dries007.tfc.objects.blocks.BlocksTFC;
import net.dries007.tfc.objects.te.TEPitKiln;
import net.dries007.tfc.util.Helpers;
import net.dries007.tfc.util.IFireable;
import net.dries007.tfc.util.IPlacableItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

public class ItemPottery extends Item implements IPlacableItem, IFireable
{
    @Override
    public ItemStack getFiringResult(ItemStack input, Metal.Tier tier)
    {
        return input; // Already fired pottery does noting.
    }

    @Override
    @SuppressWarnings("ConstantConditions")
    public EnumActionResult func_180614_a(EntityPlayer player, World worldIn, BlockPos pos, EnumHand hand, EnumFacing facing, float hitX, float hitY, float hitZ)
    {
        if (worldIn.field_72995_K) return EnumActionResult.PASS;
        if (!player.func_70093_af()) return EnumActionResult.PASS;

        if (facing != EnumFacing.UP) return EnumActionResult.FAIL;

        // todo: add player.canPlayerEdit check maybe?

        if (worldIn.func_180495_p(pos).func_177230_c() != BlocksTFC.PIT_KILN && worldIn.func_175623_d(pos.func_177982_a(0, 1, 0)))
        {
            if (!worldIn.isSideSolid(pos, EnumFacing.UP)) return EnumActionResult.FAIL;
            pos = pos.func_177982_a(0, 1, 0);
            worldIn.func_175656_a(pos, BlocksTFC.PIT_KILN.func_176223_P());
        }
        TEPitKiln te = Helpers.getTE(worldIn, pos, TEPitKiln.class);
        if (te == null) return EnumActionResult.FAIL;
        if (te.addItem(player.func_184586_b(hand), hitX < 0.5, hitZ < 0.5))
            return EnumActionResult.SUCCESS;
        return EnumActionResult.FAIL;
    }
}
